
local globleTune={}
local move1,move2=0,0
local gameLev=0
local musicproc=0
local purpleC=0
local yellowC=0

function setGameLev(gl)
  if gl >0 then gameLev=gl end

end


function createSpecTune(strKind)
  if strKind == "purple" then local tmp=createGobject("char",{char=KT[math.random(1,8)],color={112,5,106},isVisiable=true,isUpcase=false,x=math.random(0,maxW/10)*8,y=maxH/2,sp=7})
									 table.insert(globleTune,tmp)
  elseif strKind == "dozen" then local sep=math.random(0,maxW/10)*8
								  for i=0,1+gameLev do
										local tmp=createGobject("char",{char=KT[math.random(1,8)],color={255,0,0},isVisiable=true,isUpcase=false,x=sep+15*i,y=maxH/2,sp=1})
										 table.insert(globleTune,tmp)
								  end
  elseif strKind == "yellow" then local tmp=createGobject("char",{char=KT[math.random(1,8)],color={255,255,0},isVisiable=true,isUpcase=true,x=math.random(0,maxW/10)*8,y=maxH/2,sp=2})
										 table.insert(globleTune,tmp)
  end
end

function tuneTableMove()
    move1=move1+1+musicproc
	move2=move2+1
    if move1 >= 50 then
		  move1=0
          if purpleC >6 then purpleC=0 createSpecTune("purple") else purpleC=purpleC+1 end

		  if  math.random(1,15) == 3 then createSpecTune("dozen")
	      else local tmp = createGobject("char",{char=KT[math.random(1,8)],color={255,0,0},isVisiable=true,isUpcase=false,x=math.random(0,maxW/10)*8,y=maxH/2,sp=2})
				table.insert(globleTune,tmp)
		  end

		  if yellowC >30 then yellowC=0 createSpecTune("yellow") else yellowC=yellowC+1 end
	end
	if move2 >= 330 then move2=0 musicproc=musicproc+0.1*gameLev end

		for i,v in ipairs(globleTune) do
		  if v.y >= maxH-45 then Gobject.remove(v)
		                          table.remove(globleTune,i)
								   local vsp=v.sp*5+5
								    objRect[9].x1=objRect[9].x1+vsp
		   else v.y=v.y+v.sp end
		end
end

function getTunePos(tune)
  if #globleTune > 0 then
    for _,v in ipairs(globleTune) do
	  if v.char == tune then
	     return v.x,v.y
	  end
	end
   end
   return nil,nil
end



function tuneClean(tune)
   if #globleTune > 0 then
    for k,v in ipairs(globleTune) do
	  if v.char == tune then
						if v.isUpcase == false then
	                        local tmp_v=v
	                         local vsp=v.sp*5+5
	                          table.remove(globleTune,k)
	                           Gobject.remove(v)
							   if objRect[9].x1-vsp > 0 then objRect[9].x1=objRect[9].x1-vsp else objRect[9].x1=1 end
                        else globleTuneClean() end
						return
	  end
	end
   end
   local errinc=50+gameLev*6
   if objRect[9].x1 < maxW-errinc then objRect[9].x1=objRect[9].x1+errinc else objRect[9].x1=maxW end

end

function globleTuneClean()
 table.foreach(globleTune,function(k,v) Gobject.remove(v) globleTune[k]=nil end)
end
