
MusicT=require "Music"
timer=require "humptimer"
require "graphics"
require "Tune"


function currentPageUpdate(page,dt)
 if page == 2 then page2update(dt)
 end
end

function currentPageDraw(page)
 if page == 1 then page1Draw()
 elseif page == 2 then page2Draw()
 elseif page == 3 then page3Draw()
 elseif page == 4 then page4Draw()
 elseif page == 5 then page5Draw()
 elseif page == 0 then page0Draw()
 end
end

function currentPageKey(page,key)
 if page == 1 then page1Keypressed(key)
 elseif page == 2 then page2keypressed(key)
 elseif page == 3 then page3keypressed(key)
 elseif page == 4 then page4keypressed(key)
 elseif page == 5 then page5keypressed(key)
 end
end

function currentkEvent(page,e)
 if page == 1 then
   if e == 1 then page0init("movetopage2")
    elseif e == 2 then page0init("movetopage5")
     elseif e == 3 then page0init("movetopage4")
      else love.event.push("quit")
   end
 elseif page == 3 then
   if e == 4 then love.event.push("quit")
    elseif e == 5 then page0init("movetopage1")
   end
 end
 pageFlip(0)
end

function page0init(eMsg)
lprocess=0
 Event=eMsg
 love.audio.stop()
end

function page0Draw()
lprocess=lprocess+1
love.graphics.setBackgroundColor(255-lprocess,255-lprocess,255-lprocess,255-lprocess)
    if lprocess > 200 then
	    lprocess=0
	     if Event == "movetopage2" then page2Init() pageFlip(2)
		 elseif Event == "movetopage1" then page1Init() pageFlip(1)
		 elseif Event == "movetopage4" then page4init() pageFlip(4)
		 elseif Event == "movetopage5" then page5init() pageFlip(5) end
	end
end


function page1Init()
 Tflag=1
 love.graphics.setFont(love.graphics.newFont(20))
 if getGlobif(1) == 0 then
 setGlobif(1,1)
 pict={}
 for i=1,12 do
   if not (i == 5) then pict[i]=love.graphics.newImage("picture/Gtext"..i..".jpg") end
 end
 mainpage=love.graphics.newImage("picture/startpage.jpg")
 m_Source=love.audio.newSource("key/Sys1.ogg","static")
 love.audio.play(love.audio.newSource("music/p1.ogg","stream"))
 love.graphics.setCaption("Bloody Piano")
 love.keyboard.setKeyRepeat(0.5,0.5)

 end
end


function page1Keypressed(key)
love.audio.play(m_Source)
if key == "up" then if Tflag >1 then Tflag=Tflag-1 end
  elseif key == "down" then if Tflag < 4 then Tflag=Tflag+1 end
  elseif key == " " then currentkEvent(1,Tflag)
  end
end

function page1Draw()
 love.graphics.draw(mainpage,0,0)
 for i=1,4 do
  if Tflag == i then local r,g,b=love.graphics.getColor()
 					  love.graphics.setColor(215,0,0)
                       love.graphics.draw(pict[i],maxW/2-50,maxH/2+90+i*45)
					    love.graphics.setColor(r,g,b)
  else love.graphics.draw(pict[i],maxW/2-50,maxH/2+90+i*45) end
 end
end


function page2Init()
 if getGlobif(2) == 0 then
  setGlobif(2,1)
  objChar={}
  objRect={}
  objLine={}
  objPicture={}
  objCircle={}
  sf={}
  timerT={}
  KT={"a","s","d","f","h","j","k","l"} --"KT" is in upper case
  objPicture[1]=createGobject("picture",{data=love.graphics.newImage("picture/background.jpg"),color={255,255,255},isVisiable=true,x=0,y=0})
  for i in ipairs(KT) do
    objChar[i]=createGobject("char",{char=KT[i],color={255,0,0},isVisiable=true,isUpcase=false,x=maxW/8*(i-1)+45,y=maxH/2-50})
  end
  for i=0,8 do
	objLine[i+1]=createGobject("line",{color={255,0,0},isVisiable=true,x=maxW/8*i,y=0,x1=maxW/8*i,y1=maxH/2-80})
  end
  objLine[10]=createGobject("line",{color={255,0,0},isVisiable=true,x=0,y=maxH/2-80,x1=maxW,y1=maxH/2-80})
  objLine[11]=createGobject("line",{color={255,0,0},isVisiable=true,x=0,y=maxH/2,x1=maxW,y1=maxH/2})
  objLine[12]=createGobject("line",{color={255,0,0},isVisiable=true,x=0,y=maxH-25,x1=maxW,y1=maxH-25})
  objLine[13]=createGobject("line",{color={255,0,0},isVisiable=true,x=0,y=maxH-25,x1=0,y1=maxH})
  objLine[14]=createGobject("line",{color={255,0,0},isVisiable=true,x=0,y=maxH,x1=maxW,y1=maxH})
  objLine[15]=createGobject("line",{color={255,0,0},isVisiable=true,x=maxW,y=maxH-25,x1=maxW,y1=maxH})
  for i=1,8 do
    objRect[i]=createGobject("rect",{dstyle="fill",color={255,0,0},isVisiable=false,x=maxW/8*(i-1),y=0,x1=maxW/8,y1=maxH/2-80})
  end
  objRect[9]=createGobject("rect",{dstyle="fill",color={200,160,0},isVisiable=true,x=1,y=maxH-24,x1=2,y1=maxH-1})
  for i=1,10 do timerT[i]=timer.new() end
  for i=1,8 do
     sf[i]=love.audio.newSource("key/"..i..".ogg","static")
  end
  timer.addPeriodic(0.1,function() if objRect[9].x1 < maxW then objRect[9].x1=objRect[9].x1+1 else gameOverorWin("lose") end end)
  timer.addPeriodic(0.03,function() tuneTableMove() end)
 end
  if Mflag then MusicT.play(Mflag) else MusicT.play("random") end
end

function page2update(dt)
 timer.update(dt)
  MusicT.loop(dt)
  for i in ipairs(timerT) do
		    timerT[i]:update(dt)
  end
end

function page2keypressed(key)
for i=1,8 do
	  if key == KT[i] then
	       love.audio.play(sf[i])
			objChar[i].isUpcase=true
			 objRect[i].isVisiable=true
			  timer.add(0.3,function() objChar[i].isUpcase,objRect[i].isVisiable=false,false end)
			   tuneClean(key)
		 break
	  end
     end
end

function page2Draw()
  Gobject.draw()
end

function gameOverorWin(gf)
 delay=0
 Gf=gf
 Tflag=5
 Mpt=getMpt()+5
 love.audio.stop()
 MusicT.rewind(Mpt-5)
 globleTuneClean()
 love.graphics.setFont(love.graphics.newFont(30))
 objRect[9].x1=1
 for i=1,8 do objRect[i].isVisiable=false end
 if getGlobif(3) == 0 then
  setGlobif(3,1)
  pict[5]=love.graphics.newImage("picture/Gtext5.jpg")  --I messed up here,if i index the source to "Gtext4" early,that would be nice!
 end
 pageFlip(3)
end

function page3keypressed(key)
love.audio.play(m_Source)
 if key == "up" then if Tflag ~=5 then Tflag=5 end
   elseif key == "down" then if Tflag ~=4 then Tflag=4 end
   elseif key == " " then currentkEvent(3,Tflag)
 end
end

function page3Draw()
 love.graphics.setColor(50+delay,0,0)
 if Gf == "lose" then love.graphics.print("Game Over",maxW/2-70,maxH/2)
  else	 love.graphics.print("You win the game at the :",maxW/2-300,maxH/2)
          love.graphics.draw(pict[Mpt],maxW/2+100,maxH/2)
 end
 if delay < 200 then  love.graphics.setBackgroundColor(200-delay,200-delay,200-delay,200-delay)
                    delay=delay+1
    else
        if Tflag == 4 then
						    love.graphics.setColor(215,0,0)   --so,this is some tricky codes here to clean the mess as been clarified above:)
							love.graphics.draw(pict[4],maxW/2-50,maxH/2+270)
							love.graphics.setColor(255,255,255)
							love.graphics.draw(pict[5],maxW/2-50,maxH/2+225)
		else
							love.graphics.setColor(215,0,0)
							love.graphics.draw(pict[5],maxW/2-50,maxH/2+225)
							love.graphics.setColor(255,255,255)
							love.graphics.draw(pict[4],maxW/2-50,maxH/2+270)
		end
 end
end

function page4init()
 if getGlobif(4) == 0 then
    setGlobif(4,1)
    introP=love.graphics.newImage("picture/intropage.jpg")
 end
end

function page4keypressed(key)
 if key == " " then love.audio.play(m_Source) page0init("movetopage1") pageFlip(0) end
end

function page4Draw()
 love.graphics.draw(introP,0,0)
end

function page5init()
 Mflag=6
 love.graphics.setBackgroundColor(0,0,0)
end

function page5keypressed(key)
love.audio.play(m_Source)
 if key == "up" then if Mflag >6 then Mflag=Mflag-1 end
   elseif key == "down" then if Mflag < 12 then Mflag=Mflag+1 end
    elseif key == " " then page0init("movetopage1") pageFlip(0)
 end
end

function page5Draw()
 love.graphics.print("Music List:",50,100)
 for i=6,12 do
  if Mflag == i then local r,g,b=love.graphics.getColor()
 					  love.graphics.setColor(255,0,0)
                       love.graphics.draw(pict[i],75,100+(i-5)*45)
					    love.graphics.setColor(r,g,b)
  else love.graphics.draw(pict[i],75,100+(i-5)*45) end
 end
end
