
Gobject={}
Gobject.objt={}

function createGobject(otype,infor)
 local Gobj={}
  Gobj.color={}
  Gobj.type=otype
  Gobj.isVisiable=infor.isVisiable
  if infor.color ~= nil then
    for i=1,3 do Gobj.color[i]=infor.color[i] end
  end

  if otype == "line" then Gobj.x=infor.x Gobj.y=infor.y Gobj.x1=infor.x1 Gobj.y1=infor.y1

    elseif otype == "rect" then Gobj.dstyle=infor.dstyle Gobj.x=infor.x Gobj.y=infor.y Gobj.x1=infor.x1 Gobj.y1=infor.y1

	 elseif otype == "circle" then Gobj.dstyle=infor.dstyle Gobj.x=infor.x Gobj.y=infor.y Gobj.radius=infor.radius

	  elseif otype == "char" then Gobj.char=infor.char Gobj.isUpcase=infor.isUpcase Gobj.x=infor.x Gobj.y=infor.y Gobj.sp=infor.sp

	   elseif otype == "picture" then Gobj.data=infor.data  Gobj.x=infor.x Gobj.y=infor.y
  end
  return Gobject.add(Gobj)
end

function Gobject.add(Gobj)
 Gobject.objt[Gobj]=Gobj
 return Gobj
end

function Gobject.remove(Gobj)
  for k,v in pairs(Gobject.objt) do
      if Gobject.objt[k] == Gobj then Gobject.objt[k]=nil
	  end
  end
end

function Gobject.draw()
local pbj
 for _,v in pairs(Gobject.objt) do
    if v.type == "picture" then pbj=v break end
 end
 if pbj then objDraw(pbj) end
 for _,v in pairs(Gobject.objt) do
    if v.isVisiable and v.type ~= "picture" then objDraw(v) end
 end
end

function objDraw(Gobj)
   if #Gobj.color ~= 0 then
     love.graphics.setColor(Gobj.color[1],Gobj.color[2],Gobj.color[3])
	end

   if Gobj.type == "line" then love.graphics.line(Gobj.x,Gobj.y,Gobj.x1,Gobj.y1)

    elseif Gobj.type == "rect" then love.graphics.rectangle(Gobj.dstyle,Gobj.x,Gobj.y,Gobj.x1,Gobj.y1)

     elseif Gobj.type == "circle" then love.graphics.circle(Gobj.dstyle,Gobj.x,Gobj.y,Gobj.radius)

      elseif Gobj.type == "char" then if Gobj.isUpcase then
														  love.graphics.print(string.upper(Gobj.char),Gobj.x,Gobj.y)
													   else love.graphics.print(Gobj.char,Gobj.x,Gobj.y)
									  end

       elseif Gobj.type == "picture" then love.graphics.draw(Gobj.data,Gobj.x,Gobj.y)
   end
end
